package de.renew.meta;

import de.renew.engine.events.*;
import de.renew.net.NetInstance;
import java.util.HashMap;
import de.renew.util.ClassSource;
import java.lang.reflect.Method;

public   class MetaObject{
	
	private Object[] objs;
	private HashMap functionMap;
	public MetaObject(){
		functionMap=new HashMap();
	}
	public void attach(String  obj1,NetInstance netInstance){
		MetaPlugin.put(obj1,this);

	}
	public void detach(String obj1,NetInstance netInstance){
		MetaPlugin.remove(obj1);
	}
	public void registerEvent(SimulationEvent event1){
	}
	public void eventStart(SimulationEvent event){

	}
	public void eventCompleted(SimulationEvent event){
	}
	public Object base(){
		return null;
	}
	/**
		this function is to call the coresponding function with the name functionName which is defined by user
	*/
	public void call(String eventName){
		//System.out.println("------------------- 	"getName()+" "+eventName);
		String function=(String)(functionMap.get(eventName));
		if(function==null){/** TODO here should be a warning or some thing like that*/
			//System.out.println("in MetaObject.call can't find the corresponding method "+eventName);
		}else{//user have registered the name previously
			try{
				Class userPlugin=ClassSource.classForName("UserScript");
				Class<?> parameterTypes[]=new Class<?>[1];
				parameterTypes[0]=MetaObject.class;
				Method initMethod=userPlugin.getMethod(function,parameterTypes);	
				initMethod.invoke(null,this);
			}catch(Exception e){
				System.out.println("MetaObject.call "+e.toString());
			}
		}
	}

	public void register(String eventName,String functionName){
		String previous=(String)(functionMap.get(eventName));
		if(previous!=null){
			//TODO A warning should be created here.
		}
		System.out.println("in MetaObject.register event,function "+eventName+functionName);
		functionMap.put(eventName,functionName);
	}

	public void unRegister(String eventName){
		functionMap.remove(eventName);
	}
	public  String getName(){
		return null;
	}
	
	
}