/*
	added by david

*/
package de.renew.meta;

import de.renew.net.event.*;
import java.lang.*;

public class  TestPlaceEventListener implements	PlaceEventListener {

	private MetaPlace _metaPlace;
	public TestPlaceEventListener(){
		

	}

	public void setMetaPlace(MetaPlace metaPlace){
		_metaPlace=metaPlace;
	}
	public MetaPlace getMetaPlace(){
		return _metaPlace;
	}

	    /** This event method is called whenever the marking of
     *  the corresponding PlaceInstance changes dramatically
     *  (i.e. by more than one token).
     */
    public void markingChanged(PlaceEvent pe){
    		System.out.println("markingChanged "+pe.toString());
    }

    /** This event occurs when a single token (contained in the
     *  event object) is put into the corresponding PlaceInstance.
     */
    public void tokenAdded(TokenEvent te){
    
   		 System.out.println("tokenAdded "+te.toString());
		 _metaPlace.tokenAdded(te);
    	}

    /** This event occurs when a single token (contained in the
     *  event object) is removed from the corresponding PlaceInstance.
     */
    public void tokenRemoved(TokenEvent te){
    		 System.out.println("tokenRemoved "+te.toString());
    	}

    /** This event occurs when a token (contained in the
     *  event object) is tested within the corresponding PlaceInstance.
     */
    public void tokenTested(TokenEvent te){
    		 System.out.println("tokenTested "+te.toString());
    	}

    /** This event occurs when a token (contained in the
     *  event object) is untested within the corresponding PlaceInstance.
     */
    public void tokenUntested(TokenEvent te){
    		System.out.println("tokenUntested "+te.toString());
    	}
    public boolean wantSynchronousNotification(){
	return true;
    }

}
	

